if( SERVER ) then
	AddCSLuaFile( "shared.lua" );
end

if( CLIENT ) then
	SWEP.PrintName = "SMOD Kick";
	SWEP.Slot = 3;
	SWEP.SlotPos = 3;
	SWEP.DrawAmmo = false;
	SWEP.DrawCrosshair = false;
end

SWEP.Author			= "-[SB]- Spy & Kogitsune"
SWEP.Instructions	= "Left click to hit someone/something."
SWEP.Contact		= "No contacts for you :P."
SWEP.Purpose		= ""

SWEP.ViewModelFOV	= 75
SWEP.ViewModelFlip	= false

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.NextStrike = 0;
  
SWEP.ViewModel      = "models/weapons/v_kick.mdl"
SWEP.WorldModel   = ""
  
-------------Primary Fire Attributes----------------------------------------
SWEP.Primary.Delay			= 0.1 	--In seconds
SWEP.Primary.Recoil			= 0		--Gun Kick
SWEP.Primary.Damage			= 15	--Damage per Bullet
SWEP.Primary.NumShots			= 1		--Number of shots per one fire
SWEP.Primary.Cone			= 0 	--Bullet Spread
SWEP.Primary.ClipSize			= -1	--Use "-1 if there are no clips"
SWEP.Primary.DefaultClip		= -1	--Number of shots in next clip
SWEP.Primary.Automatic   		= true	--Pistol fire (false) or SMG fire (true)
SWEP.Primary.Ammo         		= "none"	--Ammo Type
 

util.PrecacheSound("player/kick/foot_swing.wav")
util.PrecacheSound("player/kick/foot_kickwall.wav")
util.PrecacheSound("player/kick/foot_kickbody.wav")
util.PrecacheSound("player/kick/kick1.wav")
util.PrecacheSound("player/kick/kick2.wav")
util.PrecacheSound("player/kick/kick3.wav")
util.PrecacheSound("player/kick/kick4.wav")
util.PrecacheSound("player/kick/kick5.wav")
util.PrecacheSound("player/kick/kick6.wav")

function SWEP:Initialize()
	if( SERVER ) then
			self:SetWeaponHoldType("normal");
	end
	self.Hit = { 
	Sound( "player/kick/foot_kickwall.wav" )};
	self.FleshHit = {
  	Sound( "player/kick/kick1.wav" ),
	Sound( "player/kick/kick2.wav" ),
	Sound( "player/kick/kick3.wav" ),
  	Sound( "player/kick/kick4.wav" ),
	Sound( "player/kick/kick5.wav" ),
	Sound( "player/kick/kick6.wav" ) } ;

end

function SWEP:Precache()
end

function SWEP:Deploy()
	self.Weapon:SendWeaponAnim( ACT_VM_IDLE );
	return true;
end

function SWEP:PrimaryAttack()
	 if( CurTime() < self.NextStrike ) then return; end
	 self.NextStrike = ( CurTime() + 1.0 );
	 timer.Simple( 0.001, self.AttackAnim, self )
	 timer.Simple( 1.0, function() self.Weapon:SendWeaponAnim( ACT_VM_IDLE ) end)
     timer.Simple( 0.30, self.ShootBullets, self )
	 self.Owner:SetAnimation( PLAYER_ATTACK1 );
end	

function SWEP:ShootBullets()
	self.Weapon:EmitSound("player/kick/foot_swing.wav");
 	local trace = self.Owner:GetEyeTrace();
	if trace.HitPos:Distance(self.Owner:GetShootPos()) <= 110 then
		if( trace.Entity:IsPlayer() or trace.Entity:IsNPC() or trace.Entity:GetClass()=="prop_ragdoll" ) then
			self.Owner:EmitSound( self.FleshHit[math.random(1,#self.FleshHit)] );
		else
			self.Owner:EmitSound( self.Hit[math.random(1,#self.Hit)] );
		end
				bullet = {}
				bullet.Num    = 1
				bullet.Src    = self.Owner:GetShootPos()
				bullet.Dir    = self.Owner:GetAimVector()
				bullet.Spread = Vector(0, 0, 0)
				bullet.Tracer = 0
				bullet.Force  = 12
				bullet.Damage = 25
			self.Owner:FireBullets(bullet)
	end
	
    if trace.Entity:GetClass() == "prop_door_rotating" then
     trace.Entity:EmitSound(Sound("physics/wood/wood_box_impact_hard3.wav"))
     trace.Entity:Fire("open", "", .001)
     trace.Entity:Fire("unlock", "", .001)
     local pos = trace.Entity:GetPos()
     local ang = trace.Entity:GetAngles()
     local model = trace.Entity:GetModel()
     local skin = trace.Entity:GetSkin()
     trace.Entity:SetNotSolid(true)
     trace.Entity:SetNoDraw(true)
     local function ResetDoor(door, fakedoor)
     door:SetNotSolid(false)
     door:SetNoDraw(false)
     fakedoor:Remove()
     end
     local norm = (pos - self.Owner:GetPos()):Normalize()
     local push = 10000 * norm
     local ent = ents.Create("prop_physics")
     ent:SetPos(pos)
     ent:SetAngles(ang)
     ent:SetModel(model)
    if(skin) then
      ent:SetSkin(skin)
    end
     ent:Spawn()
     timer.Simple(.01, ent.SetVelocity, ent, push)               
     timer.Simple(.01, ent:GetPhysicsObject().ApplyForceCenter, ent:GetPhysicsObject(), push)
	 timer.Simple(140, ResetDoor, trace.Entity, ent)
end

end

function SWEP:SecondaryAttack()
end

function SWEP:AttackAnim()
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
end 