if( SERVER ) then
	AddCSLuaFile( "shared.lua" );
end

if( CLIENT ) then
	SWEP.PrintName = ""
	SWEP.Category = "Melee Weapons"
	SWEP.Slot = 10 -- Don't let the players see it!
	SWEP.SlotPos = 10 -- Don't let the players see it!
	SWEP.DrawAmmo = false
	SWEP.DrawCrosshair = false
end

SWEP.Author			= "-[SB]- Spy & Kogitsune"
SWEP.Instructions	= "Left click to hit someone/something."
SWEP.Contact		= "No contacts for you :P."
SWEP.Purpose		= ""

SWEP.ViewModelFOV	= 75
SWEP.ViewModelFlip	= false

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.NextStrike = 0;
  
SWEP.ViewModel      = "models/weapons/v_kick_pmc.mdl"
SWEP.WorldModel   = ""
  
-------------Primary Fire Attributes----------------------------------------
SWEP.Primary.Delay			= 0.9 	--In seconds
SWEP.Primary.Recoil			= 0		--Gun Kick
SWEP.Primary.Damage			= 15	--Damage per Bullet
SWEP.Primary.NumShots		= 1		--Number of shots per one fire
SWEP.Primary.Cone			= 0 	--Bullet Spread
SWEP.Primary.ClipSize		= -1	--Use "-1 if there are no clips"
SWEP.Primary.DefaultClip	= -1	--Number of shots in next clip
SWEP.Primary.Automatic   	= true	--Pistol fire (false) or SMG fire (true)
SWEP.Primary.Ammo         	= "none"	--Ammo Type
 
-------------Secondary Fire Attributes-------------------------------------
SWEP.Secondary.Delay		= 0.9
SWEP.Secondary.Recoil		= 0
SWEP.Secondary.Damage		= 0
SWEP.Secondary.NumShots		= 1
SWEP.Secondary.Cone			= 0
SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic   	= true
SWEP.Secondary.Ammo         = "none"
 

util.PrecacheSound("player/kick/foot_swing.wav")
util.PrecacheSound("player/kick/foot_kickwall.wav")
util.PrecacheSound("player/kick/foot_kickbody.wav")
util.PrecacheSound("player/kick/kick1.wav")
util.PrecacheSound("player/kick/kick2.wav")
util.PrecacheSound("player/kick/kick3.wav")
util.PrecacheSound("player/kick/kick4.wav")
util.PrecacheSound("player/kick/kick5.wav")
util.PrecacheSound("player/kick/kick6.wav")

function SWEP:Initialize()
	if( SERVER ) then
			self:SetWeaponHoldType("normal");
	end
	self.Hit = { 
	Sound( "player/kick/foot_kickwall.wav" )};
	self.FleshHit = {
  	Sound( "player/kick/kick1.wav" ),
	Sound( "player/kick/kick2.wav" ),
	Sound( "player/kick/kick3.wav" ),
  	Sound( "player/kick/kick4.wav" ),
	Sound( "player/kick/kick5.wav" ),
	Sound( "player/kick/kick6.wav" ) } ;

end

function SWEP:Precache()
end

function SWEP:Deploy()
	 timer.Simple( 0.001, self.AttackAnim, self )
	 timer.Simple( 1.0, function()
		self.Weapon:SendWeaponAnim( ACT_VM_IDLE )
		self.Owner:SelectWeapon(self.Owner:GetNWString("Previousweapon"))
		if SERVER then
			self.Owner:StripWeapon("smod_quickkick")
		end 
		end)
     timer.Simple( 0.45, self.ShootBullets, self )
	 self.Owner:SetAnimation( PLAYER_ATTACK1 );
	return true;
end

function SWEP:PrimaryAttack()
return false
end	

function SWEP:ShootBullets()
	if CLIENT then return end
	self.Weapon:EmitSound("player/kick/foot_swing.wav");
 	local trace = self.Owner:GetEyeTrace();
	local phys = trace.Entity:GetPhysicsObject()
	if trace.HitPos:Distance(self.Owner:GetShootPos()) <= 110 then
		if( trace.Entity:IsPlayer() or trace.Entity:IsNPC() ) then
			self.Owner:EmitSound( self.FleshHit[math.random(1,#self.FleshHit)] );
			if SERVER then
				trace.Entity:TakeDamage( math.random(20, 30), self.Owner, self.Owner )
			end
		else
			self.Owner:EmitSound( self.Hit[math.random(1,#self.Hit)] );
			if phys:IsValid() then
				phys:ApplyForceOffset(self.Owner:GetAimVector():GetNormalized() * math.random(3000, 5000), trace.HitPos) -- Push it.
			else
				if SERVER then
					trace.Entity:SetVelocity(self.Owner:GetAimVector():GetNormalized() * math.random(3000, 5000)) -- Push it.
				end
			end
			if SERVER then
				trace.Entity:TakeDamage( math.random(10, 15), self.Owner, self.Owner )
			end
		end
	end
	
    if trace.Entity:GetClass() == "prop_door_rotating" then
     trace.Entity:EmitSound(Sound("physics/wood/wood_box_impact_hard3.wav"))
     trace.Entity:Fire("open", "", .001)
     trace.Entity:Fire("unlock", "", .001)
     local pos = trace.Entity:GetPos()
     local ang = trace.Entity:GetAngles()
     local model = trace.Entity:GetModel()
     local skin = trace.Entity:GetSkin()
     trace.Entity:SetNotSolid(true)
     trace.Entity:SetNoDraw(true)
     local function ResetDoor(door, fakedoor)
     door:SetNotSolid(false)
     door:SetNoDraw(false)
     fakedoor:Remove()
     end
     local norm = (pos - self.Owner:GetPos()):Normalize()
     local push = 10000 * norm
     local ent = ents.Create("prop_physics")
     ent:SetPos(pos)
     ent:SetAngles(ang)
     ent:SetModel(model)
    if(skin) then
      ent:SetSkin(skin)
    end
     ent:Spawn()
     timer.Simple(.01, ent.SetVelocity, ent, push)               
     timer.Simple(.01, ent:GetPhysicsObject().ApplyForceCenter, ent:GetPhysicsObject(), push)
	 timer.Simple(140, ResetDoor, trace.Entity, ent)
end

end

function SWEP:SecondaryAttack()
end

function SWEP:AttackAnim()
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
end 